SystemOrganization addCategory: #BTCRoassalExtension!

ROInteraction subclass: #LEKDraggableSubtree
	instanceVariableNames: 'candidateEdgesBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BTCRoassalExtension'!

!LEKDraggableSubtree class methodsFor: 'as yet unclassified' stamp: 'BenComan 10/21/2013 21:50'!
withEdges: aBlock
  	^ self new withEdges: aBlock! !

!LEKDraggableSubtree methodsFor: 'as yet unclassified' stamp: 'BenComan 10/21/2013 21:50'!
initializeElement: element
  	element on: ROMouseDragging do:
  	[    	:event |   | subtreeElements |
    		subtreeElements ifNil: [ subtreeElements := self subtreeElementsFor: element ].
    		subtreeElements do: [ :el | el translateByRealPoint:   event step ].
    		element signalUpdate
  	].! !

!LEKDraggableSubtree methodsFor: 'as yet unclassified' stamp: 'BenComan 10/21/2013 21:49'!
subtreeElementsFor: selectedElement
	| subtreeElements candidateEdges firstEdge edgesToGo finished |
  	subtreeElements := OrderedCollection new add: selectedElement ; yourself.
  	candidateEdgesBlock ifNil: [ ^ subtreeElements ].
  	candidateEdges :=   (candidateEdgesBlock value: selectedElement ) asOrderedCollection.
  	edgesToGo := candidateEdges select: [ :nextEdge | selectedElement = nextEdge from ].
  	[edgesToGo size > 0] whileTrue:
  	[  	| edge|
    		edge := edgesToGo anyOne.
    		edgesToGo remove: edge.
    		(subtreeElements includes: edge to) ifFalse:
    		[  	subtreeElements add: edge to.
      		edgesToGo addAll: (candidateEdges select: [ :nextEdge | edge to = nextEdge from] ).
   		]
  	].
  	^subtreeElements! !

!LEKDraggableSubtree methodsFor: 'as yet unclassified' stamp: 'BenComan 10/21/2013 21:50'!
withEdges: aBlock
  	candidateEdgesBlock := aBlock! !

!ROView methodsFor: '*BTCRoassalExtension' stamp: 'BenComan 10/21/2013 21:57'!
onlyEdges
	^ self elements select: [ :el | el isKindOf: ROEdge ].! !
